//+------------------------------------------------------------------+
//|                                                  exportDeals.mq4 |
//|                                        Copyright  2008, TedBeer |
//|                                           http://www.tedbeer.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, TedBeer"
#property link      "http://www.tedbeer.net"

#include <winuser32.mqh>
#import "user32.dll"
int GetParent(int hWnd);
#import

void CloseTerminal() {
Print("  CloseTerminal()");
int hwnd=WindowHandle(Symbol(), Period());
int hwnd_parent=0;

while(!IsStopped()) {
hwnd=GetParent(hwnd);
if (hwnd==0) break;
hwnd_parent=hwnd;
}
if (hwnd_parent!=0) PostMessageA(hwnd_parent, WM_CLOSE, 0, 0);
}
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   //wait for connection
   while( !IsConnected())
      Sleep(500);
   Sleep(5000);
   int i;
   int fl; //
   string fileName = "deals.txt";
   
   fl = FileOpen( fileName, FILE_CSV | FILE_READ | FILE_WRITE, '\t'); //tab delimited
   if (fl < 1){
      Print(" " + fileName + "    ,   ", GetLastError());
      return(false);
   }
   
   FileSeek(fl, 0, SEEK_END);
   int iNOrders = OrdersTotal();
   int iNHistOrders = OrdersHistoryTotal();
   int iNOpen=0, iNHist=0;

   int accNumber = AccountNumber();
   string accName = AccountName();
   
   FileWrite( fl, "User\tAccount\tTicket\tOpenTime\tCloseTime\tSymbol\tLots\tType\tOpenPrice\tClosePrice\tStopLoss\tTakeProfit\tExpiration\tProfit");
   for (i = 0; i < iNOrders; i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         switch(OrderType()) {
           case OP_BUY:
           case OP_BUYLIMIT:
           case OP_BUYSTOP:
               FileWrite( fl, accName, accNumber, OrderTicket(), OrderOpenTime(), OrderCloseTime(), OrderSymbol(), OrderLots(), OrderType(), OrderOpenPrice(), Bid, OrderStopLoss(), OrderTakeProfit(), OrderExpiration(), OrderProfit());           
               break;
           case OP_SELL:
           case OP_SELLLIMIT:
           case OP_SELLSTOP:
               FileWrite( fl, accName, accNumber, OrderTicket(), OrderOpenTime(), OrderCloseTime(), OrderSymbol(), OrderLots(), OrderType(), OrderOpenPrice(), Ask, OrderStopLoss(), OrderTakeProfit(), OrderExpiration(), OrderProfit());
               break;
           default:
               FileWrite( fl, accName, accNumber, OrderTicket(), OrderOpenTime(), OrderCloseTime(), OrderSymbol(), OrderLots(), OrderType(), OrderOpenPrice(), OrderClosePrice(), OrderStopLoss(), OrderTakeProfit(), OrderExpiration(), OrderProfit());
         }
         iNOpen++;
      }
   }

   for (i = 0; i < iNHistOrders; i++) {
    if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         FileWrite( fl, accName, accNumber, OrderTicket(), OrderOpenTime(), OrderCloseTime(), OrderSymbol(), OrderLots(), OrderType(), OrderOpenPrice(), OrderClosePrice(), OrderStopLoss(), OrderTakeProfit(), OrderExpiration(), OrderProfit());
         iNHist++;
      }
   }
   if (iNHist + iNOpen < iNOrders + iNHistOrders)
      FileWrite( fl, accName, accNumber, "  (" + (iNHist + iNOpen) + "  " + (iNOrders + iNHistOrders)+ ")");
   if (iNHist + iNOpen == 0)
      FileWrite( fl, accName, accNumber, " ");
   FileClose(fl);
//----
   CloseTerminal();
   return(0);
  }
//+------------------------------------------------------------------+